"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const quidproquo_core_1 = require("quidproquo-core");
const qpqAwsLambdaRuntimeConfigUtils_1 = require("../../../runtimeConfig/qpqAwsLambdaRuntimeConfigUtils");
const getParameters_1 = require("../../../logic/parametersManager/getParameters");
const getProcessConfigGetParameters = (runtimeConfig) => {
    return ({ parameterNames }) => __awaiter(void 0, void 0, void 0, function* () {
        const awsParameterKeys = parameterNames.map((pn) => (0, qpqAwsLambdaRuntimeConfigUtils_1.resolveParameterKey)(pn, runtimeConfig));
        const parameterValues = yield (0, getParameters_1.getParameters)(awsParameterKeys);
        return (0, quidproquo_core_1.actionResult)(parameterValues);
    });
};
exports.default = (runtimeConfig) => {
    return {
        [quidproquo_core_1.ConfigActionType.GetParameters]: getProcessConfigGetParameters(runtimeConfig),
    };
};
